<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dcs.hnyz.mapper.TemplatePageMapper">
    
    <resultMap type="TemplatePage" id="TemplatePageResult">
        <result property="pageId"    column="page_id"    />
        <result property="pageName"    column="page_name"    />
        <result property="url"    column="url"    />
        <result property="status"    column="status"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectTemplatePageVo">
        select page_id, page_name, url, status, create_by, create_time, update_by, update_time, remark from template_page
    </sql>

    <select id="selectTemplatePageList" parameterType="TemplatePage" resultMap="TemplatePageResult">
        <include refid="selectTemplatePageVo"/>
        <where>  
            <if test="pageName != null  and pageName != ''"> and page_name like concat('%', #{pageName}, '%')</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
        </where>
    </select>
    
    <select id="selectTemplatePageByPageId" parameterType="Long" resultMap="TemplatePageResult">
        <include refid="selectTemplatePageVo"/>
        where page_id = #{pageId}
    </select>

    <insert id="insertTemplatePage" parameterType="TemplatePage" useGeneratedKeys="true" keyProperty="pageId">
        insert into template_page
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="pageName != null">page_name,</if>
            <if test="url != null">url,</if>
            <if test="status != null">status,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="pageName != null">#{pageName},</if>
            <if test="url != null">#{url},</if>
            <if test="status != null">#{status},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateTemplatePage" parameterType="TemplatePage">
        update template_page
        <trim prefix="SET" suffixOverrides=",">
            <if test="pageName != null">page_name = #{pageName},</if>
            <if test="url != null">url = #{url},</if>
            <if test="status != null">status = #{status},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where page_id = #{pageId}
    </update>

    <delete id="deleteTemplatePageByPageId" parameterType="Long">
        delete from template_page where page_id = #{pageId}
    </delete>

    <delete id="deleteTemplatePageByPageIds" parameterType="String">
        delete from template_page where page_id in 
        <foreach item="pageId" collection="array" open="(" separator="," close=")">
            #{pageId}
        </foreach>
    </delete>
</mapper>